searchNodes=[{"doc":"Structure of a genetic algorithm in Elixir. The process of creating an algorithm can be thought of in three phases: Problem Definition Evolution Definition Algorithm Execution To define a Problem you need to define the specific-problems funtions: Define your solution space ( genotype/1 ): How to generate a new individual of your problem. Define your objective function ( fitness_function/2 ): How to evaluate each individual. Define your termination criteria ( terminate?/2 ): When the algorithm must to stop. Implementing a Problem A basic genetic problem consists of: genotype/0 , fitness_function/1 , and terminate?/1 . defmodule OneMax do @behaviour Genetix.Problem alias Genetix.Types.Chromosome @impl true def genotype ( opts \\ [ ] ) do size = Keyword . get ( opts , :size , 10 ) genes = for _ &lt;- 1 .. 42 , do : Enum . random ( 0 .. 1 ) % Chromosome { genes : genes , size : size } end @impl true def fitness_function ( chromosome , _opts \\ [ ] ) , do : Enum . sum ( chromosome . genes ) @impl true def terminate? ( [ best | _ ] , _opts \\ [ ] ) do best . fitness == best . size end end Notice that in this case, we use size as a hyperparameter to define the gene size. Hyperparameters It refers to the parts of the algotihm you set before the algorithm starts to configure the behavior of the algorithm: which GA operators use, size of the individuals, etc.. You can provide a Keyword with hyperparameters. Check Problem definition for more information. Examples iex&gt; alias Genetix.Problems.OneMax iex&gt; Genetix . run ( OneMax , size : 50 )","ref":"Genetix.html","title":"Genetix","type":"module"},{"doc":"","ref":"Genetix.html#crossover/2","title":"Genetix.crossover/2","type":"function"},{"doc":"","ref":"Genetix.html#evaluate/3","title":"Genetix.evaluate/3","type":"function"},{"doc":"","ref":"Genetix.html#evolve/4","title":"Genetix.evolve/4","type":"function"},{"doc":"","ref":"Genetix.html#initialize/2","title":"Genetix.initialize/2","type":"function"},{"doc":"","ref":"Genetix.html#mutation/2","title":"Genetix.mutation/2","type":"function"},{"doc":"","ref":"Genetix.html#reinsertion/4","title":"Genetix.reinsertion/4","type":"function"},{"doc":"Run a specific problem with optional hyperparameters . Check Problem definition for more information about hyperparameters .","ref":"Genetix.html#run/2","title":"Genetix.run/2","type":"function"},{"doc":"","ref":"Genetix.html#select/2","title":"Genetix.select/2","type":"function"},{"doc":"Contain functions with different aproaches / strategies to make the crossover. In genetic algorithms and evolutionary computation, crossover, also called recombination, is a genetic operator used to combine the genetic information of two parents to generate new offspring. Possibles strategies: Single-point Order-one Uniform Whole arithmetic Recombination (TODO) More information","ref":"Genetix.Evolution.CrossOver.html","title":"Genetix.Evolution.CrossOver","type":"module"},{"doc":"Single-point crossover is the most basic crossover strategy. It works like this: Choose a random number k between 0..n-1 where n is the length of the parten chromosomes. Works on blocks of genes. Split both parents at k to rpdocue four slices of genes. Swap the tails of each parent at k produce two new children.","ref":"Genetix.Evolution.CrossOver.html#crossover_cx_one_point/3","title":"Genetix.Evolution.CrossOver.crossover_cx_one_point/3","type":"function"},{"doc":"Order-one crossover, sometimes called &quot;Davis order&quot; crossover, is a crossover strategy on ordered list or permutations. Order-one is part of a unique set of crossover strategies that will preserve the integrity of a permutation without the need for chromosome repair. It works like this: Select a random slice of genes from Parent 1. Remove the values from the slice of Parent 1 from Parent 2. Insert the slice from Parten 1 into the same position in Parent 2. Repeat with a random slice from Parten 2.","ref":"Genetix.Evolution.CrossOver.html#order_one_crossover/3","title":"Genetix.Evolution.CrossOver.order_one_crossover/3","type":"function"},{"doc":"Genes in the parent chromosome are treated separately (individually). Uniform crossover works by paaring corresponding genes in a chromosome an swapping them according to a rate defined by the crossover_rate hyperparameter. By default 0.5 (50% or probability to swap both genes).","ref":"Genetix.Evolution.CrossOver.html#uniform/3","title":"Genetix.Evolution.CrossOver.uniform/3","type":"function"},{"doc":"Contain functions with different aproaches to make the evaluation. Every problem has an objetive. The goal of optimization is to maximize or minimize a value. In genetic algorithms, fitness functions tell you how well you are. You use them as a barometer to measure your progress toward the best solution.","ref":"Genetix.Evolution.Evaluate.html","title":"Genetix.Evolution.Evaluate","type":"module"},{"doc":"Use fitness_function to evaluate every individual of the population and returns a list sorted by sort_criteria hyperparameter. A fitness function is a heuristic, an approximation or estimation based on limited information.","ref":"Genetix.Evolution.Evaluate.html#heuristic_evaluation/3","title":"Genetix.Evolution.Evaluate.heuristic_evaluation/3","type":"function"},{"doc":"Contains functions with different aproaches / strategies to make the mutation. Mutation is a genetic operator used to maintain genetic diversity of the chromosomes of a population of a genetic or, more generally, an evolutionary algorithm (EA). It is analogous to biological mutation. The idea is to generate a random change to some or all of the genes in a chromosome introducing genetic diversity into the population. Possibles strategies: Shuffle / Scramble Flip (TODO) Gaussian (TODO) More information","ref":"Genetix.Evolution.Mutation.html","title":"Genetix.Evolution.Mutation","type":"module"},{"doc":"Also known as scramble mutation. Shuffle all of the genes in a given chromosome to create a new one. While shuffling maybe has no impact on the finess of a chromosome, it served to ensure some percentage of your population remained different from the rest.","ref":"Genetix.Evolution.Mutation.html#mutation_shuffle/2","title":"Genetix.Evolution.Mutation.mutation_shuffle/2","type":"function"},{"doc":"Contain functions with different aproaches / strategies to make the reinsertion. Reinsertion is the process to takin chromosomes produced from selection, crossover, and mutation and inserting them back into a population to move on the next generation.","ref":"Genetix.Evolution.Reinsertion.html","title":"Genetix.Evolution.Reinsertion","type":"module"},{"doc":"You keep a top-portion of your old population to survive the next generation. You need to define a reinsertion_rate to dictates the percentage of parent chromosomes that survives to the next generation, eg: with a population of 100 and a reinsertion_rate of 0.2 (20%), you'd keep 20 of your parents.","ref":"Genetix.Evolution.Reinsertion.html#elitist/4","title":"Genetix.Evolution.Reinsertion.elitist/4","type":"function"},{"doc":"Every chromosome in the old population is replaced with an offspring of the new population It is a type of generational replacement , creating an enterely new population so there is no overlap betweeen populations(technically, offspring directly replace parents). Pure reinsertion maintains none of the strenght of the old population and instead relies on the ability of selection, crossover, and mutation to form a strong population. Remember that is fast but you could potentially eliminate some of your stronger individuals in a population as a result.","ref":"Genetix.Evolution.Reinsertion.html#pure/4","title":"Genetix.Evolution.Reinsertion.pure/4","type":"function"},{"doc":"Also called random replacement is a reinsertion strategy that select random chromosomes from the old population to survive to the next generation. The purpose is to keep as much as genetic diversity as possible (is not too common). You need to define a reinsertion_rate to dictates the percentage of parent chromosomes that survives to the next generation, eg: with a population of 100 and a reinsertion_rate of 0.2 (20%), you'd keep 20 of your parents.","ref":"Genetix.Evolution.Reinsertion.html#uniform/4","title":"Genetix.Evolution.Reinsertion.uniform/4","type":"function"},{"doc":"Contain functions with different aproaches / strategies to make the selection. Selection is the stage of a genetic algorithm or more general evolutionary algorithm in which individual genomes are chosen from a population for later breeding (e.g., using the crossover operator). More info","ref":"Genetix.Evolution.Select.html","title":"Genetix.Evolution.Select","type":"module"},{"doc":"Also known as fitness proportionale selection, chooses parents with a probability proportional to their fitness.","ref":"Genetix.Evolution.Select.html#roulette/3","title":"Genetix.Evolution.Select.roulette/3","type":"function"},{"doc":"Often to get better parameters, strategies with partial reproduction are used. One of them is elitism, in which a small portion of the best individuals from the last generation is carried over (without any changes) to the next one. With Elitism selection, we chose the better number_of_candidates candidates (using its fitness_function). Take care because with this kind of selection we can have a lack of diversity","ref":"Genetix.Evolution.Select.html#select_elite/3","title":"Genetix.Evolution.Select.select_elite/3","type":"function"},{"doc":"Random selection pays no mind to chromosome's fitness and select a random number_of_candidates candidates from the population. Take care because this strategy is uncommon but is very useful if you goal is to obtain a high genetic diversity.","ref":"Genetix.Evolution.Select.html#select_random/3","title":"Genetix.Evolution.Select.select_random/3","type":"function"},{"doc":"Tournament selection is a strategy that pist chromosomes against one another in a tournament. While selections are still based on fitness, tounament selection introduces a strategy to choose parents that are both diverse and strong. In tournament selection, tournaments can be any n-way: the tournament size can be any nombre from 1 to the size of the population. The tournament size is defined by tournament_size hyperparameter. This implementation allows duplicates. Tournamente selection works like this: Choose a pool of n chromosomes where n is the tournament_size . Choose the fittest cohormosome from the tournament. Repeat. The beauty of tournament selection is the balance between genetic diversity and fitness. In this case we are using the max_by function","ref":"Genetix.Evolution.Select.html#select_tournament_max/3","title":"Genetix.Evolution.Select.select_tournament_max/3","type":"function"},{"doc":"Tournament selection is a strategy that pist chromosomes against one another in a tournament. While selections are still based on fitness, tounament selection introduces a strategy to choose parents that are both diverse and strong. In tournament selection, tournaments can be any n-way: the tournament size can be any nombre from 1 to the size of the population. The tournament size is defined by tournament_size hyperparameter. This implementation allows duplicates. Tournamente selection works like this: Choose a pool of n chromosomes where n is the tournament_size . Choose the fittest cohormosome from the tournament. Repeat. The beauty of tournament selection is the balance between genetic diversity and fitness. In this case we are using the min_by function","ref":"Genetix.Evolution.Select.html#select_tournament_min/3","title":"Genetix.Evolution.Select.select_tournament_min/3","type":"function"},{"doc":"Genetic problem behaviour definition with the problem-specific functions that a problem must to provide: Fitness function: How to evaluate the individual. It gives a fitness score of the individual. Genotype: How to create a new individual. Termination criteria: When the algorithm must to stop. These functions allow hyperparameters to allow controls how the algorithm works as population size, mutation rate. Each Problem implementation can define and document its hyperparameters. Common hyperparameters : evaluation_type : Evaluation operator. By default heuristic_evaluation/3 . select_type : Selection operator. By default select_elite/3 . select_rate : Selection rate. By default 0.8 . Take care of growing and shrinking population in combination with reinsertion_rate . crossover_type : Crossover operator. By defaul crossover_cx_one_point/3 . To run successfully this problem, you need to override this property using custom_crossover function. crossover_rate : Crossover rate, apply in some strategies as uniform to determine the probability to swap both genes. By default 0.5 (50% of probability). mutation_type : Mutation operator. By default mutation_shuffle/2 . To run successfully this problem, you need to override this property using custom_mutation function. mutation_probability : Mutation probability. By defaul 0.05 . sort_criteria : How to sort the population by its fitness score (max or min). By default max first. reinsertion_type : Reinsertion strategy. By defaul pure/4 . reinsertion_rate : Portion of old chromosomes to survive the next generation. By defaul 0.2 . Take care of growing and shrinking population in combination with select_rate . statistics : Map name-function with statistic functions to apply. By default it calculates the minimum, maximum and the mean of the population (based on it fitness score). Optional hyperparameters : size : Size of the genotype. By default 10 . population_size : Total number of individuals to run the algorithm. By default 100 .","ref":"Genetix.Problem.html","title":"Genetix.Problem","type":"behaviour"},{"doc":"The fitness function determines how fit an individual is (the ability of an individual to compete with other individuals). Returns: It gives a fitness score to each individual. The probability that an individual will be selected for reproduction is based on its fitness score.","ref":"Genetix.Problem.html#c:fitness_function/2","title":"Genetix.Problem.fitness_function/2","type":"callback"},{"doc":"Generate a new individual.","ref":"Genetix.Problem.html#c:genotype/1","title":"Genetix.Problem.genotype/1","type":"callback"},{"doc":"Its defines when the algorithm must to stop returning true or continue in other case.","ref":"Genetix.Problem.html#c:terminate?/3","title":"Genetix.Problem.terminate?/3","type":"callback"},{"doc":"Hyperparameters type. Hyperparameters are represented as a Keyword . Are optional. Take a look to Genetix.Problem module documentation or specific Problem implementation to know the details of the hyperparameters supported.","ref":"Genetix.Problem.html#t:hyperparameters/0","title":"Genetix.Problem.hyperparameters/0","type":"type"},{"doc":"A specific genetic problem implementation for NQueens. The N Queen is a combinatorial optimization problem, the objective is to configure NQueens on chess board so that no queen theatens another.any() Hyperparameters size number of queens. Default 8 . Examples iex&gt; Genetix.Evolution . run ( Genetix.Problems.NQueens , size : 8 )","ref":"Genetix.Problems.NQueens.html","title":"Genetix.Problems.NQueens","type":"module"},{"doc":"Fitness function implementation for NQueen problem.","ref":"Genetix.Problems.NQueens.html#fitness_function/2","title":"Genetix.Problems.NQueens.fitness_function/2","type":"function"},{"doc":"Genotype implementation for NQueen problem. Permutation.","ref":"Genetix.Problems.NQueens.html#genotype/1","title":"Genetix.Problems.NQueens.genotype/1","type":"function"},{"doc":"Terminate implementation for NQueen problem.","ref":"Genetix.Problems.NQueens.html#terminate?/3","title":"Genetix.Problems.NQueens.terminate?/3","type":"function"},{"doc":"A specific genetic problem implementation for OneMax. The One-Max problem is a trivial problem: What is the maximum sum of a bitstring (a string consisting of only 1s and 0s) of length N. Hyperparameters size length of the bitestring (0s, 1s). Default 42 . Examples iex&gt; Genetix.Evolution . run ( Genetix.Problems.OneMax , size : 1000 )","ref":"Genetix.Problems.OneMax.html","title":"Genetix.Problems.OneMax","type":"module"},{"doc":"Fitness function implementation for OneMax problem.","ref":"Genetix.Problems.OneMax.html#fitness_function/2","title":"Genetix.Problems.OneMax.fitness_function/2","type":"function"},{"doc":"Genotype implementation for OneMax problem. Bitstring.","ref":"Genetix.Problems.OneMax.html#genotype/1","title":"Genetix.Problems.OneMax.genotype/1","type":"function"},{"doc":"Terminate implementation for OneMax problem.","ref":"Genetix.Problems.OneMax.html#terminate?/3","title":"Genetix.Problems.OneMax.terminate?/3","type":"function"},{"doc":"A specific problem implementation to obtain @target (a-z no whitespaces) string. Hyperparameters target an a-z no whitespaces string. By default elixir . max_generation , termination criteria. By default 10_000 . Examples iex&gt; Genetix.Evolution . run ( Genetix.Problems.Speller , target : &quot;elixir&quot; , max_generation : 1 )","ref":"Genetix.Problems.Speller.html","title":"Genetix.Problems.Speller","type":"module"},{"doc":"Fitness function implementation for Speller problem.","ref":"Genetix.Problems.Speller.html#fitness_function/2","title":"Genetix.Problems.Speller.fitness_function/2","type":"function"},{"doc":"Genotype implementation for Speller problem. Permutation","ref":"Genetix.Problems.Speller.html#genotype/1","title":"Genetix.Problems.Speller.genotype/1","type":"function"},{"doc":"Terminate implementation for Speller problem.","ref":"Genetix.Problems.Speller.html#terminate?/3","title":"Genetix.Problems.Speller.terminate?/3","type":"function"},{"doc":"A specific genetic problem implementation for ZeroMax. The Zero-Max problem is a trivial problem: What is the minimum sum of a bitstring (a string consisting of only 1s and 0s) of length N. Hyperparameters size length of the bitestring (0s, 1s). Default 42 . sort_criteria due its a minimal optimization problem, we need to override the defaul value based on max, with the &amp;&lt;=2 operator. Examples iex&gt; Genetix.Evolution . run ( Genetix.Problems.ZeroMax , size : 1000 , sort_criteria : &amp; &lt;= / 2 )","ref":"Genetix.Problems.ZeroMax.html","title":"Genetix.Problems.ZeroMax","type":"module"},{"doc":"fitness function implementation for ZeroMax problem.","ref":"Genetix.Problems.ZeroMax.html#fitness_function/2","title":"Genetix.Problems.ZeroMax.fitness_function/2","type":"function"},{"doc":"Genotype implementation for ZeroMax problem. Bitstring","ref":"Genetix.Problems.ZeroMax.html#genotype/1","title":"Genetix.Problems.ZeroMax.genotype/1","type":"function"},{"doc":"Terminate function implementation for ZeroMax problem.","ref":"Genetix.Problems.ZeroMax.html#terminate?/3","title":"Genetix.Problems.ZeroMax.terminate?/3","type":"function"},{"doc":"Chromosome type definition that represents a single solution. A Chromosome represents one solution to the problem you are trying to solve. Solutions are encoded into a collection of genes. The Chromosome is then evaluated based on some criteria you define. Chromosomes must be defined as very &quot;self-aware&quot; containing all of the information necessary to repair and evaluate themselves.","ref":"Genetix.Types.Chromosome.html","title":"Genetix.Types.Chromosome","type":"module"},{"doc":"Chromosome type. Chromosomes are represented as a %Chromosome{} . At a minimum a chromosome needs :genes . Fields :genes : Enum containing genotype representation. :id : string unique id of chromosome. :size : non_neg_integer representing size of chromosome. :age : non_neg_integer representing age of chromosome. :fitness : number representing fitness(es) of chromosome.","ref":"Genetix.Types.Chromosome.html#t:t/0","title":"Genetix.Types.Chromosome.t/0","type":"type"},{"doc":"Genealogy tree server implementation. A genealogy tree is a directed grapgh that points from parent chromosome to child chromosome and shows the transitions of the evolution from first population to last population.","ref":"Utilities.Genealogy.html","title":"Utilities.Genealogy","type":"module"},{"doc":"","ref":"Utilities.Genealogy.html#add_chromosome/2","title":"Utilities.Genealogy.add_chromosome/2","type":"function"},{"doc":"","ref":"Utilities.Genealogy.html#add_chromosome/3","title":"Utilities.Genealogy.add_chromosome/3","type":"function"},{"doc":"","ref":"Utilities.Genealogy.html#add_chromosomes/1","title":"Utilities.Genealogy.add_chromosomes/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Utilities.Genealogy.html#child_spec/1","title":"Utilities.Genealogy.child_spec/1","type":"function"},{"doc":"","ref":"Utilities.Genealogy.html#get_tree/0","title":"Utilities.Genealogy.get_tree/0","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Utilities.Genealogy.html#init/1","title":"Utilities.Genealogy.init/1","type":"function"},{"doc":"","ref":"Utilities.Genealogy.html#start_link/1","title":"Utilities.Genealogy.start_link/1","type":"function"},{"doc":"Profile the performance of your genetic algorithm","ref":"Utilities.Profiler.html","title":"Utilities.Profiler","type":"module"},{"doc":"get analysis records and sum them up","ref":"Utilities.Profiler.html#run/2","title":"Utilities.Profiler.run/2","type":"function"},{"doc":"Statistics server implementation","ref":"Utilities.Statistics.html","title":"Utilities.Statistics","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Utilities.Statistics.html#child_spec/1","title":"Utilities.Statistics.child_spec/1","type":"function"},{"doc":"","ref":"Utilities.Statistics.html#clean/0","title":"Utilities.Statistics.clean/0","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Utilities.Statistics.html#init/1","title":"Utilities.Statistics.init/1","type":"function"},{"doc":"","ref":"Utilities.Statistics.html#insert/2","title":"Utilities.Statistics.insert/2","type":"function"},{"doc":"","ref":"Utilities.Statistics.html#lookup/1","title":"Utilities.Statistics.lookup/1","type":"function"},{"doc":"","ref":"Utilities.Statistics.html#start_link/1","title":"Utilities.Statistics.start_link/1","type":"function"},{"doc":"Genetix is a framework to solve problems using genetic algorithms in Elixir. The process of creating an algorithm can be thought of in three phases: Problem Definition Evolution Definition Algorithm Execution You only need to define the Genetix.Problem and run it using Genetix.run/2 function! To define a new Genetix.Problem you need to define the specific-problems funtions: Define your solution space ( genotype/1 ): How to generate a new individual of your problem. Define your objective function ( fitness_function/2 ): How to evaluate each individual. Define your termination criteria ( terminate?/2 ): When the algorithm must to stop. Depends of the case, you may need define custom hyperparameters . Internally, genetix understand these: Common hyperparameters : evaluation_type : Evaluation operator. By default heuristic_evaluation/3 . select_type : Selection operator. By default select_elite/3 . select_rate : Selection rate. By default 0.8 . Take care of growing and shrinking population in combination with reinsertion_rate . crossover_type : Crossover operator. By defaul crossover_cx_one_point/3 . To run successfully this problem, you need to override this property using custom_crossover function. crossover_rate : Crossover rate, apply in some strategies as uniform to determine the probability to swap both genes. By default 0.5 (50% of probability). mutation_type : Mutation operator. By default mutation_shuffle/2 . To run successfully this problem, you need to override this property using custom_mutation function. mutation_probability : Mutation probability. By defaul 0.05 . sort_criteria : How to sort the population by its fitness score (max or min). By default max first. reinsertion_type : Reinsertion strategy. By defaul pure/4 . reinsertion_rate : Portion of old chromosomes to survive the next generation. By defaul 0.2 . Take care of growing and shrinking population in combination with select_rate . statistics : Map name-function with statistic functions to apply. By default, it calculates the minimum, maximum an the mean of the population (based on the fitness score). Optional hyperparameters : size : Size of the genotype. By default 10 . population_size : Total number of individuals to run the algorithm. By default 100 . To learn more and get started, check out our guides and docs . NOTE : This framework is based on the Genetic algorithms in Elixir: Solve Problems Using Evolution The Pragmatic Programmers, by Sean Moriarity.","ref":"readme.html","title":"Genetix","type":"extras"},{"doc":"Add :genetix to the list of dependencies in mix.exs : def deps do [ { :genetix , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"Genetix - Installation","type":"extras"},{"doc":"The One-Max problem is a trivial problem: What is the maximum sum of a bitstring (a string consisting of only 1s and 0s) of length N. You only need to define your OneMax problem and if you need it, define your own hyperparameters to customize its behavior (in that case, is not needed). Remember, a basic genetic problem consists of: genotype/0 , fitness_function/1 , and terminate?/1 . defmodule OneMax do @behaviour Genetix.Problem alias Genetix.Types.Chromosome @impl true def genotype ( opts \\\\ [ ] ) do # Notice that in this case, we use `size` as a hyperparameter to define the gene size. size = Keyword . get ( opts , :size , 10 ) genes = for _ &lt;- 1 .. 42 , do : Enum . random ( 0 .. 1 ) % Chromosome { genes : genes , size : size } end @impl true def fitness_function ( chromosome , _opts \\\\ [ ] ) , do : Enum . sum ( chromosome . genes ) @impl true def terminate? ( [ best | _ ] , _opts \\\\ [ ] ) do best . fitness == best . size end end You can run Genetix.run(Genetix.Problems.OneMax, size: 100) to solve the problem. If you want, you can take a look to genetix/problems for other problems implemented as example.","ref":"readme.html#a-quick-example-solving-one-max-problem","title":"Genetix - A quick example: Solving One-Max problem","type":"extras"},{"doc":"The goal of all the problems you are going to solve are related with optimize and objetive. In all the algorithms, you must to define the problem, configure the algorithm and run it until you obtain a solution. Sometimes you need a way to track the progress of an evolution over the time: Analyze how your population's fitness grew over time How the distribution of fitness changed between generations ... Those insight can help you make decisions about how to reconfigure or adjust your algorithms. For this purpose, Genetix provides Statistics that uses ETS to store the evolution of the population over time. You can override the default statistics with the statistics hyperparameter. Once the algorithm ends you can access your statistics running Utilities.Statistics.lookup/1 function. An example of use: iex&gt; Genetix . run ( Genetix.Problems.OneMax , size : 100 ) # once the algorithm ends iex&gt; { _ , zero_gen_stats } = Utilities.Statistics . lookup ( 0 ) iex&gt; { _ , fivethousand_gen_stats } = Utilities.Statistics . lookup ( 5000 ) An example defining custom statistics: def get_percentile_90 ( population ) do sorted_population = Enum . map ( population , fn c -&gt; c . fitness end ) |&gt; Enum . sort ( ) n = length ( sorted_population ) k = round ( 0.9 * n ) if k == 0 do Enum . at ( sorted_population , 0 ) else Enum . at ( sorted_population , k - 1 ) end end Genetix . run ( Genetix.Problems.OneMax , size : 10 , statistics : %{ percentile_90 : &amp; get_percentile_90 / 1 } )","ref":"readme.html#tracking-genetic-algorithms","title":"Genetix - Tracking Genetic Algorithms","type":"extras"},{"doc":"Genetix provides a way to track the evolution of each chromosome using libgraph . A genealogy tree is a directed grapgh that points from parent chromosome to child chromosome and shows the transitions of the evolution from first population to last population. You can explore the genealogy tree generated after running your algorithm: Genetix . run ( Genetix.Problems.OneMax , size : 50 ) genealogy = Utilities.Genealogy . get_tree ( ) IO . inspect ( Graph . vertices ( genealogy ) ) If you run this, you'll see a very long list of chromosomes. Take a look to the libgraph doc for more information.","ref":"readme.html#tracking-genealogy","title":"Genetix - Tracking Genealogy","type":"extras"},{"doc":"Elixir is a language that wasn't designed to be extremely efficient at computationally expensive tasks. Genetix allows benchmark and profile your genetic algorithms. Benchmarking is the process of evaluating your code from a performance point of view (establishing performance metrics for an entire operation to compare between other operations). Profiling is the process of evaluating specific aspects of a program in space or time to add in performance optimization (to understand the behavior of a program talling which operation spends most of its time or what function a program invokes the most offering detailed insights into where you should try to optimize the most). Benchmarking your algorithm allows you to determine if the optimizations you are making are having impact on the overall performance of your algorithm. Genetix uses benchee for benchmarking. Benchee provides a lot of information out of the box. You can check example(s) of benchmarking using benchee under bench folder and run mix run bench/benchmark.exs to see the results of the benchmarks. Check the benchee documentation for more information. Genetix also uses benchee_html to generate a nice looking HTML report where individual graphs can also be exported as PNG images under benchmarks folder. Genetix also uses exprof to profile your genetics algorithms with Utilities.Profiler . An example how to use Utilities.Profiler : iex&gt; Utilities.Profiler . run ( Genetix.Problems.ZeroMax , sort_criteria : &amp; &lt;= / 2 ) HH :MM :SS . mm [ info ] Running Genetix.Problems.ZeroMax FUNCTION CALLS % TIME [ uS / CALLS ] -- -- -- -- -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] counters :get / 2 1 0.00 0 [ 0.00 ] counters :add / 3 1 0.00 0 [ 0.00 ] ... rand :uniform / 1 5071 4.82 2253 [ 0.44 ] erlang :send / 2 979 5.08 2374 [ 2.42 ] &#39;Elixir.Enum&#39; :split_list / 3 21394 5.80 2710 [ 0.13 ] &#39;Elixir.Enum&#39; :&#39;-sum/1-lists^foldl/2-0-&#39; / 2 47486 11.28 5272 [ 0.11 ] -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - -- -- - [ -- -- -- -- -- ] Total : 224888 100.00 % 46749 [ 0.21 ] 99.56 You should see a long list of results indicating where your genetic algorithm spends most of its time. In this example you 'll notices that most of the work in the algorithm happens in list functions and random number generations.","ref":"readme.html#benchmarking-and-profiling-genetic-algorithms","title":"Genetix - Benchmarking and Profiling Genetic Algorithms","type":"extras"},{"doc":"Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Genetix - License","type":"extras"}]